// ApiSend.cpp : M߃t@C쐬֐
//

#include	"stdafx.h"

#include	"ApiSend.h"

#include	"SfCsSys.h"

extern "C" {

//**********************************************************************
// ֐        : MakeSendMission
// @\          : M߃t@C쐬
// Ăяo      : MakeSendMission( SENDFAX_MISSION *pInfo, int *piError )
//           : pInfo   = M߃t@C쐬|C^
//               : piError = G[AG[擾p|C^
// o          : Ԓl  TRUE  : I
//               :       FALSE : s
//               :               *piError = G[R[h
//               : 
//               :   yG[R[hz
//               :       SENDFAX_ERR_NoMisFolder      ... M߃tH_݂܂
//               :       SENDFAX_ERR_GetMisFolder     ... M߃tH_̎擾Ɏs܂
//               :       SENDFAX_ERR_GetTempFolder    ... ꎞtH_̎擾Ɏs܂
//               :       SENDFAX_ERR_GetTempFile      ... ꎞt@C̎擾Ɏs܂
//               :       SENDFAX_ERR_MakeMisName      ... M߃t@C̍쐬Ɏs܂
//               :       SENDFAX_ERR_PARAM_INFO       ... ֐G[: M߃t@C쐬񂪎w肳Ă܂B
//               :       SENDFAX_ERR_PARAM_SENDNUM    ... ֐G[: 搔̎w肪 0 łB
//               :       SENDFAX_ERR_PARAM_SENDINFO   ... ֐G[: 񂪎w肳Ă܂B
//               :       SENDFAX_ERR_PARAM_FAX        ... ֐G[: FAXԍw肳Ă܂B
//               :       SENDFAX_ERR_PARAM_DOCorCOVER ... ֐G[: Met@CAtt@CAƂɎw肳Ă܂B
//               :       SENDFAX_ERR_PARAM_DOCNAME    ... ֐G[: Met@Cw肳Ă܂B
//               : 
// L      :   M߃t@C쐬쐬܂B
// 쐬        : 
// 쐬        : 2005.07.04
//**********************************************************************
BOOL APIENTRY	MakeSendMission( SENDFAX_MISSION *pInfo, int *piError )
{
	BOOL	bRet = FALSE;	// Ԓl ... l͎s

	int	iErrorDummy;	// NULLp_~[G[R[hݒ

	int	i;

	BOOL	bTemp = FALSE;		// ꎞt@C쐬ꂽۂ

	char	szTempFolder[MAX_PATH+1];	// ꎞt@CtH_p
	char	szTempFile[MAX_PATH+1];		// ꎞt@Cp

	char	szSendMisFolder[MAX_PATH+1];	// M߃tH_p
	char	szSendMis[MAX_PATH+1];			// M߃t@Cp

	SENDFAX_SENDINFO	*pSendInfo;	// p
	char	*pDocName;				// Mep

	char	szSection[32];	// ZNVݒp
	char	szKey[32];		// L[ݒp
	char	szWork[512];	// Ɨp

	if( !piError ) {
		// G[R[h擾p|C^Ƀ_~[ݒ
		piError = &iErrorDummy;
	}
	*piError = SENDFAX_SUCCESS;		// G[R[hɏlݒ ... I

	/////////////////////////////////////////////////////////////////////////////
	// (1)  ȒPȈ̓e`FbN
	// 

		// M߃t@C쐬`FbN
	if( !pInfo ) {
		*piError = SENDFAX_ERR_PARAM_INFO;
		goto	EXIT;
	}
		// 搔`FbN
	if( !pInfo->iSendNum ) {
		*piError = SENDFAX_ERR_PARAM_SENDNUM;
		goto	EXIT;
	}
		// `FbN
	for( i = 0 ;  i < pInfo->iSendNum ; i++ ) {
		pSendInfo = *( pInfo->ppSend + i );
		if( !pSendInfo ) {
			*piError = SENDFAX_ERR_PARAM_SENDINFO;
			goto	EXIT;
		}
			// FAXԍ`FbN
		if( !pSendInfo->szFax[0] ) {
			*piError = SENDFAX_ERR_PARAM_FAX;
			goto	EXIT;
		}
	}
		// Met@CAtt@C`FbN
	if( !pInfo->iDocNum && !pInfo->pCoverName ) {
		*piError = SENDFAX_ERR_PARAM_DOCorCOVER;
		goto	EXIT;
	}
		// Met@C`FbN
	if( pInfo->iDocNum ) {
		for( i = 0 ;  i < pInfo->iDocNum ; i++ ) {
			pDocName = *( pInfo->ppDocName + i );
			if( !pDocName ) {
				*piError = SENDFAX_ERR_PARAM_DOCNAME;
				goto	EXIT;
			}
		}
	}

	/////////////////////////////////////////////////////////////////////////////
	// (2)  M߃tH_pX̃`FbN
	// 

	if( SFCSSYS_CheckSubFolder( SFCS_SMODE_SENDMIS ) != SFCS_SUCCESS ) {
		*piError = SENDFAX_ERR_NoMisFolder;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (3)  M߃tH_pX擾
	// 

	if( !SFCSSYS_GetSubFolder( SFCS_SMODE_SENDMIS, szSendMisFolder, MAX_PATH + 1 ) ) {
		*piError = SENDFAX_ERR_GetMisFolder;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (4)  ꎞt@CpX擾 ydvz
	// 
    //      M߃t@Č`́AINIt@C`Ȃ̂ŁAt@C̏óA
	//    WritePrivateProfileString()yWin32APIz gp܂B
    //    AOSɂAWritePrivateProfileString()yWin32APIz gpĂ
    //    ۂ̃t@Cւ̏õ^C~OقȂׁASTARFAX 
	//    r[ȏԂœǂݏoꂪ܂BhׂɁAUAꎞt@C
	//    쐬Al[悤ɂ܂B
	// 

	if( !GetTempPath( sizeof(szTempFolder), szTempFolder ) ) {
		*piError = SENDFAX_ERR_GetTempFolder;
		goto	EXIT;
	}
	if( !GetTempFileName( szTempFolder, "SFCS", 0, szTempFile ) ) {
		*piError = SENDFAX_ERR_GetTempFile;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (5)  ꎞt@C֏
	// 

	bTemp = TRUE;

	// ZNV: [SendInfo]  ... M̂߂̑

	// E  Acount     ... AJEg([URɗpłGA) (ő64oCg)
	if( pInfo->szAcount[0] ) {
		WritePrivateProfileString( "SendInfo", "Acount", pInfo->szAcount, szTempFile );
	}

	// E  Num        ... M搔
	wsprintf( szWork, "%d", pInfo->iSendNum );
	WritePrivateProfileString( "SendInfo", "Num", szWork, szTempFile );

	// ZNV: [Send%d]    ... M̂߂̑e  (1`)
	for( i = 0 ;  i < pInfo->iSendNum ; i++ ) {
		pSendInfo = *( pInfo->ppSend + i );

		wsprintf( szSection, "Send%d", i + 1 );

		// E  Fax        ... FAXԍ (ő128oCg)
		WritePrivateProfileString( szSection, "Fax", pSendInfo->szFax, szTempFile );
		// E  Company    ... Ж (ő128oCg)
		if( pSendInfo->szCompany[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szCompany );
			WritePrivateProfileString( szSection, "Company", szWork, szTempFile );
		}
		// E  Division   ...  (ő128oCg)
		if( pSendInfo->szDivision[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szDivision );
			WritePrivateProfileString( szSection, "Division", szWork, szTempFile );
		}
		// E  Position   ... E (ő128oCg)
		if( pSendInfo->szPosition[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szPosition );
			WritePrivateProfileString( szSection, "Position", szWork, szTempFile );
		}
		// E  Name       ...  (ő128oCg)
		if( pSendInfo->szName[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szName );
			WritePrivateProfileString( szSection, "Name", szWork, szTempFile );
		}
		// E  Title      ... h (ő128oCg)
		if( pSendInfo->szTitle[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szTitle );
			WritePrivateProfileString( szSection, "Title", szWork, szTempFile );
		}
		// E  Telephone  ... dbԍ (ő128oCg)
		if( pSendInfo->szTelephone[0] ) {
			WritePrivateProfileString( szSection, "Telephone", pSendInfo->szTelephone, szTempFile );
		}
		// E  ZipCode    ... X֔ԍ (ő128oCg)
		if( pSendInfo->szZipCode[0] ) {
			WritePrivateProfileString( szSection, "ZipCode", pSendInfo->szZipCode, szTempFile );
		}
		// E  Address1   ... Z1 (ő128oCg)
		if( pSendInfo->szAddress1[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szAddress1 );
			WritePrivateProfileString( szSection, "Address1", szWork, szTempFile );
		}
		// E  Address2   ... Z2 (ő128oCg)
		if( pSendInfo->szAddress2[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szAddress2 );
			WritePrivateProfileString( szSection, "Address2", szWork, szTempFile );
		}
		// E  FCode      ... eR[hԍ (ő20oCg)
		if( pSendInfo->szFCode[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szFCode );
			WritePrivateProfileString( szSection, "FCode", szWork, szTempFile );
		}
		// E  FreeArea   ... [URɗpłGA (ő128oCg)
		if( pSendInfo->szFreeArea[0] ) {
			wsprintf( szWork, "\"%s\"", pSendInfo->szFreeArea );
			WritePrivateProfileString( szSection, "FreeArea", szWork, szTempFile );
		}
		// E  Speed      ... ʐMx ("0":, "1":, "2":, "3":ᑬ)
		if( pSendInfo->iSpeed ) {
			wsprintf( szWork, "%d", pSendInfo->iSpeed );
			WritePrivateProfileString( szSection, "Speed", szWork, szTempFile );
		}
		// E  Comp       ... k ("0":, "1":MH, "2":MR, "3":MMR)
		if( pSendInfo->iComp ) {
			wsprintf( szWork, "%d", pSendInfo->iComp );
			WritePrivateProfileString( szSection, "Comp", szWork, szTempFile );
		}
		// E  Ecm        ... G[ ("0":, "1":p, "2":pȂ)
		if( pSendInfo->iEcm ) {
			wsprintf( szWork, "%d", pSendInfo->iEcm );
			WritePrivateProfileString( szSection, "Ecm", szWork, szTempFile );
		}
		// E  Line       ... Mw (0`)
		if( pSendInfo->bLine ) {
			wsprintf( szWork, "%d", pSendInfo->iLine );
			WritePrivateProfileString( szSection, "Line", szWork, szTempFile );
		}
		// E  Priority   ... D揇 (0`15)
		if( pSendInfo->bPriority ) {
			wsprintf( szWork, "%d", pSendInfo->iPriority );
			WritePrivateProfileString( szSection, "Priority", szWork, szTempFile );
		}
		// E  Time       ... M ("YYYYMMDDHHMMSS")
		if( pSendInfo->bTime ) {
			wsprintf( szWork, "%s", pSendInfo->szTime );
			WritePrivateProfileString( szSection, "Time", szWork, szTempFile );
		}
	}

	// ZNV: [Doc]       ... Me
	// E  Num        ... e
	if( pInfo->iDocNum ) {

		wsprintf( szWork, "%d", pInfo->iDocNum );
		WritePrivateProfileString( "Doc", "Num", szWork, szTempFile );

		// E  Name%d     ... et@CpX  (1`)
		for( i = 0 ;  i < pInfo->iDocNum ; i++ ) {
			pDocName = *( pInfo->ppDocName + i );
			wsprintf( szKey, "Name%d", i + 1 );
			wsprintf( szWork, "\"%s\"", pDocName );
			WritePrivateProfileString( "Doc", szKey, szWork, szTempFile );
		}
		// E  Delete     ... ߃t@CAMe폜 ("0":폜Ȃ, "1":폜)
		if( pInfo->bDocDelete ) {
			WritePrivateProfileString( "Doc", "Delete", "1", szTempFile );
		}
	}

	// ZNV: [Cover]     ... t
	// E  Name       ... tt@CpX(.txt)
	if( pInfo->pCoverName ) {
		wsprintf( szWork, "\"%s\"", pInfo->pCoverName );
		WritePrivateProfileString( "Cover", "Name", szWork, szTempFile );
	}

	// ZNV: [User]      ... M
	// E  UserInfo   ... ML^ ("L^ʒu,L^") (ő140oCg)
	//                    ("0":L^Ȃ, "1":e̓ɋL^, "2":e̊OɋL^)
	if( pInfo->szUserInfo[0] ) {
		wsprintf( szWork, "\"%s\"", pInfo->szUserInfo );
		WritePrivateProfileString( "User", "UserInfo", szWork, szTempFile );
	}
	// E  UserID     ... Ǔdbԍ (FAXIDƂāAt@NV~ɒʒm܂B) (ő20oCg)
	if( pInfo->szUserID[0] ) {
		wsprintf( szWork, "\"%s\"", pInfo->szUserID );
		WritePrivateProfileString( "User", "UserID", szWork, szTempFile );
	}

	/////////////////////////////////////////////////////////////////////////////
	// (6)  ꎞt@C̃tbV ydvz
	// 
    //      OSɂAWritePrivateProfileString()yWin32APIz gpĂ
    //    ۂ̃t@Cւ̏õ^C~OقȂׁAK̃tbV
	//    XebvKvłB
	// 

	WritePrivateProfileString( NULL, NULL, NULL, szTempFile );

	/////////////////////////////////////////////////////////////////////////////
	// (7)  M߃t@C쐬
	// 

	// ŗL̃t@C쐬
	if( !SFCSSYS_GetUniqFileName( szSendMisFolder, SFCS_FRM_SENDMIS, szSendMis ) ) {
		*piError = SENDFAX_ERR_MakeMisName;
		goto	EXIT;
	}

	/////////////////////////////////////////////////////////////////////////////
	// (8)  ꎞt@C𑗐M߃t@CɃl[
	// 

	DeleteFile( szSendMis );	// Ôߍ폜
	MoveFile( szTempFile, szSendMis );	// l[

	bRet = TRUE;	// I

EXIT:

	// G[́Aꎞt@C폜
	if( bTemp && !bRet ) {
		DeleteFile( szTempFile );
	}

	return bRet;
}

}
