// TestDlg.cpp : Cve[V t@C
//

#include "stdafx.h"

#include <windowsx.h>

#include "PrtCli.h"
#include "TestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestDlg _CAO

/////////////////////////////////////////////////////////////////////////////
// 

CTestDlg::CTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDlg)
	m_uiPage = 1;
	//}}AFX_DATA_INIT

	m_hPrt = (SFCSPRT_HANDLE)NULL;
}

/////////////////////////////////////////////////////////////////////////////
// 

void CTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDlg)
	DDX_Control(pDX, IDC_SPIN_PAGE, m_csPage);
	DDX_Control(pDX, IDC_COMBO_PAPER, m_ccPaper);
	DDX_Text(pDX, IDC_EDIT_PAGE, m_uiPage);
	DDV_MinMaxUInt(pDX, m_uiPage, 1, 99);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDlg)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDlg bZ[W nh

/////////////////////////////////////////////////////////////////////////////
// 

BOOL CTestDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	// ݒ
	m_csPage.SetRange( 1 , 99 );

	// STARFAX 
	{
		int	iError;

		// STARFAX 
		if( !( m_hPrt = SFCSPRT_Init( &iError ) ) ) {
			MessageBox( "STARFAX v^hCo܂", CAP_APR_PRTCLI, MB_ICONSTOP | MB_OK );
			EndDialog( IDCANCEL );
		}
		else {

			// ݒ\pTCY mF
			DWORD	dwPaper = SFCSPRT_CheckPaper( m_hPrt );

			if( dwPaper & SFCSPRT_PAPER_A4 ) {
				m_ccPaper.AddString( "A4" );
			}
			if( dwPaper & SFCSPRT_PAPER_B4 ) {
				m_ccPaper.AddString( "B4" );
			}
			if( dwPaper & SFCSPRT_PAPER_A3 ) {
				m_ccPaper.AddString( "A3" );
			}
			if( dwPaper & SFCSPRT_PAPER_A5 ) {
				m_ccPaper.AddString( "A5" );
			}
			if( dwPaper & SFCSPRT_PAPER_B5 ) {
				m_ccPaper.AddString( "B5" );
			}
			if( dwPaper & SFCSPRT_PAPER_LETTER ) {
				m_ccPaper.AddString( "^[" );
			}
			if( dwPaper & SFCSPRT_PAPER_LEGAL ) {
				m_ccPaper.AddString( "[K" );
			}
			if( dwPaper & SFCSPRT_PAPER_TABLOID ) {
				m_ccPaper.AddString( "^uCh" );
			}
			if( dwPaper & SFCSPRT_PAPER_STATEMENT ) {
				m_ccPaper.AddString( "Xe[gg" );
			}
			m_ccPaper.SetCurSel( 0 );
		}
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/////////////////////////////////////////////////////////////////////////////
// 

void CTestDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	
	if( m_hPrt ) {

		// STARFAX I
		SFCSPRT_Term( m_hPrt );
		m_hPrt = (SFCSPRT_HANDLE)NULL;

	}
}

/////////////////////////////////////////////////////////////////////////////
// 

void CTestDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	
	CDialog::OnOK();

	char	szPaper[32+1];
	DWORD	dwPaper = 0;
	int	iError;

	HDC	hDc;

	UpdateData( TRUE );

	// pTCY w
	m_ccPaper.GetLBText( m_ccPaper.GetCurSel(), szPaper );
	if( !lstrcmp( szPaper, "A4" ) ) {
		dwPaper = SFCSPRT_PAPER_A4;
	}
	else if( !lstrcmp( szPaper, "B4" ) ) {
		dwPaper = SFCSPRT_PAPER_B4;
	}
	else if( !lstrcmp( szPaper, "A3" ) ) {
		dwPaper = SFCSPRT_PAPER_A3;
	}
	else if( !lstrcmp( szPaper, "A5" ) ) {
		dwPaper = SFCSPRT_PAPER_A5;
	}
	else if( !lstrcmp( szPaper, "B5" ) ) {
		dwPaper = SFCSPRT_PAPER_B5;
	}
	else if( !lstrcmp( szPaper, "^[" ) ) {
		dwPaper = SFCSPRT_PAPER_LETTER;
	}
	else if( !lstrcmp( szPaper, "[K" ) ) {
		dwPaper = SFCSPRT_PAPER_LEGAL;
	}
	else if( !lstrcmp( szPaper, "^uCh" ) ) {
		dwPaper = SFCSPRT_PAPER_TABLOID;
	}
	else if( !lstrcmp( szPaper, "Xe[gg" ) ) {
		dwPaper = SFCSPRT_PAPER_STATEMENT;
	}

	// STARTDOC 
	if( hDc = SFCSPRT_StartDoc( m_hPrt, "PRTCLI", dwPaper, &iError ) ) {

		int	iPage;
		BOOL	bOK = TRUE;

		// v
		::SetCursor( AfxGetApp()->LoadStandardCursor( IDC_WAIT ) );

// DEBUG  //////////////////////////////////////////////////////////
#ifdef	_DEBUG
		{
			#define	DEBUG_OUT( pTITLE, iVal ) \
			{	\
				char	szDebMsg[256];	\
				wsprintf( szDebMsg, "%s = %d\n", pTITLE, iVal );	\
				OutputDebugString( szDebMsg );	\
			}
			DEBUG_OUT( "HORZSIZE", GetDeviceCaps( hDc, HORZSIZE ) );
			DEBUG_OUT( "VERTSIZE", GetDeviceCaps( hDc, VERTSIZE ) );
			DEBUG_OUT( "HORZRES", GetDeviceCaps( hDc, HORZRES ) );
			DEBUG_OUT( "VERTRES", GetDeviceCaps( hDc, VERTRES ) );
			DEBUG_OUT( "LOGPIXELSX", GetDeviceCaps( hDc, LOGPIXELSX ) );
			DEBUG_OUT( "LOGPIXELSY", GetDeviceCaps( hDc, LOGPIXELSY ) );
			DEBUG_OUT( "NUMCOLORS", GetDeviceCaps( hDc, NUMCOLORS ) );
			DEBUG_OUT( "BITSPIXEL", GetDeviceCaps( hDc, BITSPIXEL ) );
			DEBUG_OUT( "PHYSICALWIDTH", GetDeviceCaps( hDc, PHYSICALWIDTH ) );
			DEBUG_OUT( "PHYSICALHEIGHT", GetDeviceCaps( hDc, PHYSICALHEIGHT ) );
			DEBUG_OUT( "PHYSICALOFFSETX", GetDeviceCaps( hDc, PHYSICALOFFSETX ) );
			DEBUG_OUT( "PHYSICALOFFSETY", GetDeviceCaps( hDc, PHYSICALOFFSETY ) );
		}	
#endif
// DEBUG  //////////////////////////////////////////////////////////

		for( iPage = 0 ; iPage < (int)m_uiPage ; iPage++ ) {

			// STARTPAGE 
			if( !( bOK = SFCSPRT_StartPage( m_hPrt ) ) ) {
				break;
			}

			// y[W 
			{
				HFONT	hFont = NULL;

				HFONT	hFontOld;
				char	szPage[64];

				// tHgw
				hFont = CreateFont( -128, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FIXED_PITCH | FF_ROMAN, "lr SVbN" );
				hFontOld = SelectFont( hDc, hFont );

				// eLXgo
				wsprintf( szPage, "PAGE: %d / %d", iPage + 1, m_uiPage );
				TextOut( hDc, 128, 64, szPage, lstrlen( szPage ) );

				// eLXgo
				TextOut( hDc, 128, 320, "eXg", lstrlen( "eXg" ) );

				SelectObject( hDc, hFontOld );
				DeleteFont( hFont );

			}

			// ENDPAGE 
			if( !( bOK = SFCSPRT_EndPage( m_hPrt ) ) ) {
				break;
			}

		}
		if( bOK ) {
			// ENDDOC 
			SFCSPRT_EndDoc( m_hPrt );
		}
		else {
			// ABORTDOC 
			SFCSPRT_AbortDoc( m_hPrt );
		}

		// v
		::SetCursor( AfxGetApp()->LoadStandardCursor( IDC_ARROW ) );
	}

	return;
}
